<template>
  <div>
    <nav
      class="navbar navbar-expand-md navbar-dark fixed-top"
      style="background-color: #00686b; height: 65px"
    >
      <div class="container">
        <div class="container d-flex justify-content-between">
          <span
            class="d-xl-none collapsed btn btn-none"
            data-bs-toggle="collapse"
            data-bs-target="#navbarCollapse"
            aria-controls="navbarCollapse"
            aria-expanded="false"
            aria-label="Toggle navigation"
            style="margin-left: -30px; font-size: 18px"
          >
            <span class="navbar-toggler-icon"></span>
          </span>

          <h3 class="mt-2">
            <router-link
              class="text-white text-decoration-none"
              style="margin-left: -10px"
              :to="{ name: 'home' }"
              >Aksirelawan
            </router-link>
          </h3>

          <div style="color: white; font-size: 18px; margin-top: 10px">
            <div class="position-relative">
              <i class="bi bi-cash-stack"></i>
              <span
                class="
                  position-absolute
                  top-0
                  start-100
                  translate-middle
                  badge
                  rounded-pill
                  bg-success
                "
                v-if="!guest"
              >
                {{ transactions }}
              </span>
            </div>
          </div>
        </div>

        <div class="navbar-collapse collapse" id="navbarCollapse">
          <div class="navbar-nav me-auto mb-2 mb-md-0"></div>

          <div class="d-flex justify-content-start" v-if="guest">
            <router-link
              class="btn btn-outline-light btn-sm mx-2"
              :to="{ name: 'login' }"
              >Login</router-link
            >
            <router-link
              class="btn btn-outline-light btn-sm"
              :to="{ name: 'register' }"
              >Register</router-link
            >
          </div>
          <div class="d-flex dropdown" v-if="!guest">
            <a
              class="
                btn btn-none
                text-white text-decoration-none
                dropdown-toggle
              "
              role="button"
              id="dropdownMenuLink"
              data-bs-toggle="dropdown"
              aria-expanded="false"
            >
              <img
                class="rounded-circle"
                :src="
                  user.Data.User.photo ? user.Data.User.photo : 'https://dummyimage.com/640x4:3/'
                "
                alt=""
                width="30px"
                height="30px"
              />
              {{ user.Data.User.name }}
            </a>

            <ul
              class="dropdown-menu dropdown-menu-lg-end"
              aria-labelledby="dropdownMenuLink"
            >
              <li><router-link :to="{ name: 'Update-Profile' }" class="dropdown-item " >Update Profile</router-link></li>
              <li><a class="dropdown-item" @click="logout">Logout</a></li>
            </ul>
          </div>
        </div>
      </div>
    </nav>

    <div style="margin-top: 65px">
      <div class="container d-flex flex-row-reverse" v-if="alert">
        <div
          class="
            alert alert-success alert-dismissible
            fade
            show
            position-absolute
          "
          style="width: 50%"
        >
          {{ alertText }}
          <button type="button" class="btn-close" @click="closeAlert"></button>
        </div>
      </div>
      <div class="container d-flex flex-row-reverse" v-if="alertError">
        <div
          class="
            alert alert-danger alert-dismissible
            fade
            show
            position-absolute
          "
          style="width: 50%"
        >
          {{ alertText }}
          <button type="button" class="btn-close" @click="closeAlert"></button>
        </div>
      </div>
      <router-view></router-view>
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters, mapMutations } from "vuex";
import Button from "../../vendor/laravel/breeze/stubs/inertia-vue/resources/js/Components/Button.vue";

export default {
  components: { Button },
  name: "App",
  data: () => ({}),
  computed: {
    ...mapGetters({
      transactions: "transaction/transactions",
      user: "auth/user",
      isLogin : "auth/isLogin",
      guest: "auth/guest",
      alert: "alert/alert",
      alertError: "alert/alertError",
      alertText: "alert/alertText",
    }),

    // transactions() {
    //   return this.$store.getters.transaction;
    // },
  },

  methods: {
    ...mapMutations({
      setTransactions: "transaction/setTransactions",
      setAuth: "auth/set",
      setIsLogin: "auth/setisLogin",
      getAlert: "alert/getAlert",
      closeAlert: "alert/closeAlert",
    }),

    logout() {
      axios({
        method: "post",
        url: "/api/Auth/Logout",
        headers: {
          Authorization: "Bearer " + this.user.Data.Token,
        },
      })
        .then((response) => {
          this.setAuth({});
          this.setTransactions(0)
          this.setIsLogin(false)
          this.getAlert("logout Berhasil");
          this.$router.push("/");

        })
        .catch((error) => {
          alert("catch error");
          console.log(error.data);
        });
    },

    ...mapActions({
      checkToken: "auth/cekToken",
    }),
  },
  mounted() {
    if (this.isLogin) {
      this.checkToken(this.user);
    }
  },
};
</script>
